/*#################################################################################################
#  $Id: main.prg,v 1.4 2006/07/02 00:56:55 fivewin Exp $
#  Lira Lira Oscar Joel [oSkAr]
#  Proyecto     : TRMChartX
#  Archivo      : Main.prg
#  Creacion     : 06/28/2006, 17:03
#  Actualizacion: :>: 07/01/2006 20:03
#################################################################################################*/
#include "Fivewin.ch"
#include "RMChartX.ch"

STATIC lEsp := .t.  // espanol (Spanish) = .t. ; English (ingles) = .f.
/*---------------------------------------------------------------------------*/
FUNCTION Main()
   LOCAL nOp

 IF lEsp

   nOp :=  MsgList( { "En una Window",;
                      "En Una Window partiendo de un RMC",;
                      "En un Dialog",;
                      "En un Dialog Desde Recursos",;
                      "En un Folder desde codigo",;
                      "En un Folder desde Recursos" },;
              "TRMChartX by oSkAr [Selecciona el Test a Ejecutar]" )
 ELSE

   nOp :=  MsgList( { "In a Window",;
                      "In a Window based on an RMC",;
                      "In a Dialog",;
                      "In a Dialog From Resources",;
                      "In a Folder from code",;
                      "In a Folder from Resources" },;
              "TRMChartX by oSkAr [Selection of the Test to Execute]" )
 ENDIF

   DO CASE
      CASE nOp == 1
         Test01()
      CASE nOp == 2
         Test02()
      CASE nOp == 3
         Test03()
      CASE nOp == 4
         Test04()
      CASE nOp == 5
         Test05()
      CASE nOp == 6
         TEST06()
   ENDCASE
   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
FUNCTION Test06()
   LOCAL oDlg, oFld, oChart, oFld2, oChart2

   /*
      Tambien podemos verificar si el control esta instalado antes de iniciarlo
      Also we verify if the control is installed before initiating it.
   */
   IF !TRMChartX():verifica()
      MsgInfo( "The OCX is not installed" )
      RETURN NIL
   ENDIF

   DEFINE Dialog oDlg Resource "DL_FOLDER"
      oDlg:SetText( "RMChart In Folders from resources" )

      Redefine Folder oFld Id 101 Of oDlg Items "Chart", "Folder" Dialogs "DL_FLDCHART", "DL_FLDFLD"
      oChart := TRMChartX():New( oFld:aDialogs[01], 101 )

      Redefine Folder oFld2 Id 101 Of oFld:aDialogs[02] Items "Chart", "Otro" Dialogs "DL_FLDCHART"
      oChart2 := TRMChartX():New( oFld2:aDialogs[01], 101 )

   Activate Dialog oDlg ON Init (;
      ConfiguraChart( oChart, oFld:aDialogs[01], .T. ),;
      ConfiguraChart( oChart2, oFld2:aDialogs[01], .T. ) )
   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
FUNCTION Test05()
   LOCAL oDlg, oFld, oChart, oFld2, oChart2, cMsg 

   IF lEsp
      cMsg := "No tienes instalado el OCX de RMChart."
   ELSE
      cMsg := "The RMChart OCX is not installed."
   ENDIF

   /*
      Tambien podemos verificar si el control esta instalado antes de iniciarlo
      Also we verify if the control is installed before initiating it.
   */
   IF !TRMChartX():verifica()
      MsgInfo( cMsg )
      RETURN NIL
   ENDIF

   DEFINE Dialog oDlg Size 600, 400

      oDlg:SetText( "Chart Creado en un folder" )
      @ 5, 5 Folder oFld Of oDlg Size 290,190 Pixel
      oChart := TRMChartX():New( oFld:aDialogs[01] )

      @ 0, 0 Folder oFld2 Of oFld:aDialogs[02] Size 270,190
      oChart2 := TRMChartX():New( oFld2:aDialogs[02] )

   Activate Dialog oDlg Center On Init ( ConfiguraChart( oChart, oFld:aDialogs[01], .T. ),;
      ConfiguraChart( oChart2, oFld2:aDialogs[02], .T. ) )
   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
FUNCTION Test03()
   LOCAL oDlg, oChart, cMsg 

   IF lEsp
      cMsg := "No tienes instalado el OCX de RMChart."
   ELSE
      cMsg := "The RMChart OCX is not installed."
   ENDIF

   /*
      Tambien podemos verificar si el control esta instalado antes de iniciarlo
      Also we verify if the control is installed before initiating it.
   */
   IF !TRMChartX():verifica()
      MsgInfo( cMsg )
      RETURN NIL
   ENDIF

   DEFINE Dialog oDlg Size 600,400 pixel

      oChart := TRMChartX():New( oDlg )

   Activate Dialog oDlg ON Init ConfiguraChart( oChart, oDlg, .T. ) Center
   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
FUNCTION Test04()
   LOCAL oDlg, oChart, cMsg 

   IF lEsp
      cMsg := "No tienes instalado el OCX de RMChart."
   ELSE
      cMsg := "The RMChart OCX is not installed."
   ENDIF


   /*
      Tambien podemos verificar si el control esta instalado antes de iniciarlo,
      si al metodo Verifica le pasamos el parametro .T. le estamos diciendo a la clase
      que autoinstale el ocx

      Also we verify if the control is installed before initiating it. If the 
      method Verifica() passes back the parameter .T. it is saying to the class
      that autoinstalls the ocx.
   */
   IF !TRMChartX():verifica( .T. )
      MsgInfo( cMsg )
      RETURN NIL
   ENDIF

   DEFINE Dialog oDlg Resource "DL_RMCHART"

      oChart := TRMChartX():New( oDlg, 101 )

   Activate Dialog oDlg ON Init ConfiguraChart( oChart, oDlg, .F. ) Center
   RETURN NIL


/*-----------------------------------------------------------------------------------------------*/
FUNCTION ConfiguraChart( oChart, oDlg, lAdjust )
   oChart:Activate()
   oChart:RMCFile = "10Bigcom.rmc"
   oChart:Region( 1 ):Caption:Titel := "TRMChartX Test By oSkAr [" + Version() + "]"
   IF lAdjust
      oChart:oControl:nWidth  := 580
      oChart:oControl:nHeight := 380
   ENDIF
   RETURN NIL



/*-----------------------------------------------------------------------------------------------*/
FUNCTION Test02()
   LOCAL oWnd, oChart
   DEFINE Window oWnd
      oWnd:setText( "RMChartX Test By oSkAr [ Cargando el Grafico de un rmc ]" )

      // Creamos el control
      oChart := TRMChartX():New( oWnd )

      // Verificamos que el control se haya creado bien
      IF !oChart:lOk
         oWnd:END()
         RETURN NIL
      ENDIF

      // Cargamos el Grafico de un fichero
      oChart:RMCFile := "c:\xx\10Bigcom.rmc"

      // Cambiamos el Titulo
      // We change the title
      oChart:Region( 1 ):Caption:Titel := "TRMChartX Test By oSkAr [" + Version() + "]"

      // Cambiamos los valores en la serie 1 de tipo barra
      // We change the values into the bar type of series 1...
      oChart:Region( 1 ):BarSeries( 1 ):DataString := oChart:ArrayToString( { 185000, 142500, 190000, 196000, 120000, 230000, 140000, 184000, 153500, 160000, 140000, 152000 } )

      // Cambiamos los valores en la serie 2 de tipo line
      // We change the values into the bar type of series 2...
      oChart:Region( 1 ):LineSeries( 1 ):DataString := oChart:ArrayToString( { 12,15,13,18,20,5,9,3,2,5,22,13} )

      // establecemos que el grafico tendra 12 valores, ya que el del fichero solo tenia 10
      // We establish that the graphic has 12 values, whereas the file only has 10...
      oChart:Region( 1 ):LabelAxis:TickCount := 12

      // aadimos las 2 etiquetas faltantes
      // We add the 2 missing labels...
      ochart:Region( 1 ):LabelAxis:Labeltext := "One And*another"

      // Ponemos el control como cliente de nuestra window
      // We put the control in as the client of our window...
      oWnd:oClient := oChart:oControl

      // si queremos cambiar todas las etiquetas
      // If we want to change all of the labels...
      *oChart:Region( 1 ):LabelAxis:LabelString := "Et1*Et2*Et3*Et4*Et5*Et6*Et7*Et8*Et9*Et10*Et11*Et12"

      // si queremos cambiar los valores minimos y maximos que va a manejar el grafico
      // If we want to change the minimum and maximum values of the graph...
      *oChart:Region( 1 ):DataAxis( 1 ):MinValue := 0
      *oChart:Region( 1 ):DataAxis( 1 ):MaxValue := 300000

      //de esta forma podemos ir cambiando todas las propiedades del grafico y hacerlo a nuestro gusto
      //partiendo de un grafico ya diseado en un fichero rmc, para crear esto archivos puedes usar el RMCDesigne
      //que viene incluido en la instalacion del control

      // On this form we can change all the properties of the graph and do it to our taste
      // based on a graph already designed in an RMC file. To create an RMC file, you can use 
      // the RMCDesigner.exe that comes included in the installation of the RMChart control.

   Activate Window oWnd
   RETURN NIL


/*-----------------------------------------------------------------------------------------------*/
Function Test01()
   LOCAL oWnd, oChart, oRegion, oGrid, oDataAxis, oDataAxis2, oLabelAxis, ;
         oBarSeries, oLineSeries, cMsg
   DEFINE Window oWnd

      IF lEsp
         cMsg := "Creando el grafico totalmente desde codigo"
      ELSE
         cMsg := "Creating the graph completely from code"
      ENDIF

      oWnd:setText( "RMChartX Test By oSkAr [ "+cMsg+" ]" )

      oChart := TRMChartX():New( oWnd )
      IF !oChart:lOk
         oWnd:END()
         RETURN NIL
      ENDIF

      oChart:Addregion()
      oRegion := oChart:Region( 1 )
      oRegion:ShowBorder    := .T.
      oRegion:Footer        := "http://oskar.sytes.net"
      oRegion:AddCaption()
      oRegion:Caption:Titel := "TRMChartX Test By oSkAr [" + Version() + "]"

      oRegion:AddGrid()
      oGrid := oRegion:Grid
      oGrid:AsGradient    := .T.
      oGrid:Left      := 0
      oGrid:Top       := 0
      oGrid:Width     := 0
      oGrid:Height    := 0

      oRegion:AddDataAxis()
      oDataAxis :=  oRegion:DataAxis( 1 )
      oDataAxis:Alignment      = RMC_DATAAXISBOTTOM
      oDataAxis:MinValue       = 0
      oDataAxis:MaxValue       = 10000
      oDataAxis:TickCount      = 11
      oDataAxis:Fontsize       = 8
      oDataAxis:TextColor      = ColorDefault
      oDataAxis:LineColor      = ColorDefault
      oDataAxis:LineStyle      = RMC_LINESTYLESOLID
      oDataAxis:DecimalDigits  = 0
      oDataAxis:AxisUnit           = ""
      oDataAxis:AxisText           = "Closing Index (Line series)\11"

      oRegion:AddDataAxis()
      oDataAxis2 := oRegion:DataAxis( 2 )
      oDataAxis2:Alignment      = RMC_DATAAXISTOP
      oDataAxis2:MinValue       = 0
      oDataAxis2:MaxValue       = 10000
      oDataAxis2:DecimalDigits  = 0
      oDataAxis2:AxisUnit       = ""
      oDataAxis2:AxisText       = "Share volumes (Bar series)\11"

      oRegion:AddLabelAxis()
      oLabelAxis := oRegion:LabelAxis
      oLabelAxis:AxisCount         = 1
      oLabelAxis:Alignment     = RMC_LABELAXISLEFT
      oLabelAxis:Fontsize      = 8
      oLabelAxis:TextColor     = ColorDefault
      oLabelAxis:TextAlignment = RMC_TEXTCENTER
      oLabelAxis:LineColor     = ColorDefault
      oLabelAxis:LineStyle     = RMC_LINESTYLESOLID

      oRegion:AddBarSeries()
      oBarSeries := oRegion:BarSeries( 1 )
      oBarSeries:SeriesType       = RMC_BARSINGLE
      oBarSeries:SeriesStyle      = RMC_BAR_HOVER
      oBarSeries:Lucent           = .F.
      oBarSeries:Color            = ColorLightGoldenrod
      oBarSeries:Horizontal       = .F.
      oBarSeries:WhichDataAxis    = 2
      oBarSeries:ValueLabelOn     = .F.
      oBarSeries:PointsPerColumn  = 1
      oBarSeries:HatchMode        = RMC_HATCHBRUSH_OFF
      oBarSeries:DataString       = "1000*2000*3000*4000*5000*6000*5000*4000*3000*2000"

      oRegion:AddLineSeries()
      oLineSeries := oRegion:LineSeries( 1 )
      oLineSeries:SeriesType             = RMC_LINE
      oLineSeries:SeriesStyle            = RMC_LINE_FLAT
      oLineSeries:LineStyle        = RMC_LSTYLE_LINE
      oLineSeries:Lucent         = .T.
      oLineSeries:Color            = ColorRed
      oLineSeries:SymbolStyle     = RMC_SYMBOL_POINT
      oLineSeries:WhichDataAxis    = 1
      oLineSeries:ValueLabelOn     = .F.
      oLineSeries:HatchMode        = RMC_HATCHBRUSH_OFF
      oLineSeries:DataString = "1000*2000*3000*4000*5000*6000*5000*4000*3000*2000"

      oWnd:oClient := oChart:oControl

   Activate Window oWnd
   Return NIL