/*#################################################################################################
#  $Id: TRMChartX.prg,v 1.3 2006/07/03 22:29:57 fivewin Exp $
#  Lira Lira Oscar Joel [oSkAr]
#  Proyecto     : TOBrowse
#  Archivo      : TRMChartX.prg
#  Creacion     : 06/28/2006, 17:03
#  Actualizacion: :>: 07/03/2006 17:36
#################################################################################################*/
#include "Fivewin.ch"

STATIC lEsp := .t. // File-wide language selection: espaol (Spanish) = .t. ; English (ingles) = .f.

/*-----------------------------------------------------------------------------------------------*/
CLASS TRMChartX
   DATA oControl
   DATA oChart
   CLASSDATA lOk Init .F.
   METHOD New()
   METHOD ArrayToString()
   ERROR  HANDLER ERROR()
   METHOD Verifica()
   METHOD Activate()
   METHOD Install()
   METHOD RMCFile( cFile ) SETGET
   METHOD cRMColor()
ENDCLASS

/*-----------------------------------------------------------------------------------------------*/
METHOD New( oWnd, nId ) CLASS TRMChartX
LOCAL cMsg := ""

   IF lEsp
      cMsg := "No tienes instalado el control RMChart"
   ELSE
      cMsg := "The RMChart OCX control is not installed."
   ENDIF

   ::Verifica()
   IF !::lOk
      MsgInfo( cMsg )  // OCX not installed.
      RETURN SELF
   ENDIF

   IF nId != NIL
      ::oControl := TActiveX():Redefine( nId, oWnd, "RMChart.RMChartX" )
   ELSE
      ::oControl := TActiveX():New( oWnd, "RMChart.RMChartX" )
   ENDIF

   IF !Empty( oWnd:hWnd )
      ::Activate()
   ENDIF

   RETURN SELF

/*-----------------------------------------------------------------------------------------------*/
METHOD Activate()
   ::oChart   := TOleAuto():New( ActXPdisp( ::oControl:hActiveX ) )
   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
METHOD Verifica( lAutoInstall )
LOCAL cMsg := "",cYes := "", cRun := ""

   IF lEsp
      cMsg := "RMChart OCX No esta instalado, deseas instalarlo ?"
      cYes := "Si"
      cRun := "Instalando el control OCX RMChart."
   ELSE
      cMsg := "RMChart OCX is not installed. Install it now?"
      cYes := "Yes"
      cRun := "Installing the RMChart OCX control."
   ENDIF

   DEFAULT lAutoInstall := .F.
   IF !::lOk
      IF IsActiveX( "RMChart.RMChartX" )
         ::lOk := .T.
      ELSE
         IF lAutoInstall .OR.;
            Alert( cMsg, { cYes, "No" } ) == 1
            MsgRun( cRun, NIL, { || ::Install() } )
         ENDIF
      ENDIF
  ENDIF
  RETURN ::lOk

/*-----------------------------------------------------------------------------------------------*/
METHOD Install()
   LOCAL cOrigen, cDestino, cMsg, cTitle

   IF lEsp 
      cTitle := "En sistemas XP esto puede causar inestabilidad, Eliminala por favor"
      cMsg1  := "Cuidado tiene la "
      cMsg2  := " en el directorio de la app"
      cError := "Ocurrio error en la instalacion del control"   
   ELSE
      cTitle := "XP systems without this can be unstable - please fix"
      cMsg1  := "Make sure that "
      cMsg2  := " is in the app directory."
      cError := "Error while trying to install the OCX control."
   ENDIF

   cOrigen  := ".\RMChart\RMChart.dll"
   cDestino := GetSysDir() + "\RMChart.dll"
   IF !File( cOrigen ); RETURN NIL; ENDIF
   Copy File &cOrigen TO &cDestino

   cOrigen  := ".\RMChart\RMChart.ocx"
   cDestino := GetSysDir() + "\RMChart.ocx"
   IF !File( cOrigen ); RETURN NIL; ENDIF
   Copy File &cOrigen TO &cDestino

   WinExec( "REGSVR32 " + cDestino + " /s" )

   cDestino := ".\gdiplus.dll"
   IF IsWin95() .OR. IsWin2000()
      cOrigen  := ".\RMChart\W9X2K\gdiplus.dll"
      IF !File( cOrigen ); RETURN NIL; ENDIF
      Copy File &cOrigen TO &cDestino
   ELSE
      IF File( cDestino )
         MsgInfo( cMsg1 + cDestino + cMsg2 + CRLF +;
                  cTitle )
      ENDIF
   ENDIF

   ::lOk := IsActiveX( "RMChart.RMChartX" )
   IF !::lOk
      MsgInfo( cError )
   ENDIF

   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
METHOD ArrayToString( aDatos )
   LOCAL cString := ""
   AEval( aDatos, { |aDato| cString += "*" + AllTrim( IF( ValType( aDato ) == "N", Str( aDato ), aDato ) ) } )
   RETURN SubStr( cString, 2 )

/*-----------------------------------------------------------------------------------------------*/
METHOD cRMColor( nR, nG, nB )
   DEFAULT nR := 0, nG := 0, nB := 0
   RETURN "&HFF" + DecToHex( nR ) + DecToHex( nG ) + DecToHex( nB )

/*-----------------------------------------------------------------------------------------------*/
METHOD RMCFile( cFile )
   ::oChart:RMCFile := cFile
   RETURN NIL

/*-----------------------------------------------------------------------------------------------*/
METHOD ERROR( uParam1 )
   LOCAL cMsg, nParam, uRet
   nParam := PCount()
   cMsg   := __GetMessage()
   IF SubStr( cMsg, 1, 1 ) == "_"
      cMsg := SubStr( cMsg, 2 )
   ENDIF
   DO CASE
      CASE nParam == 0
         uRet := ::oChart:Get( cMsg )
      CASE nParam == 1
         uRet := ::oChart:Get( cMsg, @uParam1 )
   ENDCASE
   RETURN uRet
/*-----------------------------------------------------------------------------------------------*/
  // Llame esta funcin de su app para poner la lengua para mensajes. 
  // La lengua de falta es el espaol, la lengua de Oskar.

  // Call this function from your app to set the language for messages. 
  // The default language is Spanish (espaol), Oskar's language.
FUNCTION SetLanguage(lEspanol)

  lEsp := lEspanol

RETURN nil
/*-----------------------------------------------------------------------------------------------*/